.TH sysreport 1 "10th Oct 1994"
.SH NAME
sysreport \- Report on schedules for Sysprog Groups
.SH SYNOPSIS
.B sysreport
.B report-file ...
.SH DESCRIPTION
.LP
.I sysreport
generates a statistics report of several schedules produced with
.I syssched.
The maximum, minimum and average score of the heuristic function and the
maximum, minimum and average number of students in one of their wish
groups is given as well as the standard deviation of the above. If
available, maximum, minimum, and average real- user- and system times
are also given. These times are generated if the example script in
.I syssched(1)
is used and the reports redirected from standard output of the scheduler
are used. A sample call of the report program would be
.EX
    sysreport 94ws.*
.EE

Note: For selecting a good schedule, the scores should be used, not the
number of students in their wish groups. The latter can find schedules
that put too many students in a group or leave groups half empty. This
is due to problems with a heuristic search and explained in more detail
in
.I syssched(1).
If the score is used as an indicator for good schedules, the schedules
not fulfilling the requirements for the number of students in a group
will not be found because they will have a very bad score.

A strategy for selecting the best schedule is calling the 
.B sysreport
program with all output files available and grepping for the maximum
score reported by 
.B sysreport.

.SH IMPLEMENTATION
The report program is written in perl.

.SH SEE ALSO
.BR syssched(1),
.BR anm2sched(1),
.BR perl(1),
.BR grep(1)

.SH AUTHOR
Ralf Schlatterbeck

