.TH syssched 1 "10th Oct 1994"
.SH NAME
syssched \- Generate schedule for Sysprog Groups
.SH SYNOPSIS
.B syssched
[
.B \-w <number>
]
.B randseed
.B file
.SH DESCRIPTION
.LP
.I syssched
generates a schedule for the sysprog course. A heuristic search
algorithm is used to find a good solution. 
A flood algorithm is used for the search. The heuristic parameters are highly
tuned to achieve a good solution. The first implementation did'nt even
find solutions of the quality achievable by hand. This is the reason why
only one of the heuristic parameters, the wish rewardstep is runtime
selectable. This parameter selectable with the 
.B \-w
option specifies in what steps the reward for students in wishgroups
increases. The default for this parameter is 0, i.e. no special reward
is given if a student is in his number one wish group or in his number
three wish group. This is normally the best setting because we want as
many students in their wish groups as possible. If this parameter is set
higher, a higher reward is offered depending on the wish list.
If set to 5 for example the reward of the number one wish is 10 points
higher than the reward for the number three wish. The maximum number
that can be given with the
.B -w
switch is 10.

The randseed value is used to seed the random number generator for the
heuristic search algorith. It should be a number between 0 and MAXINT.
The file is the student input data generated by 
.I anm2sched.

The 
.B syssched
program produces an output file. It is called
.I studliste
and contains the list of students with their group number in the form
needed by 
.I spor2.
Note that the list is not sorted but 
.I spor2
requires a sorted list and produces no error messages if the list is
not sorted. The list has to be sorted before importing it with
.I spor2.

On standard output the actual group allocation is given together with
the number of students in each group and the number of students given
their first, second and third wish group. We expect this program to be
run with standard output redirected to a file and run several times,
perhaps on several machines to find an acceptable solution in a short
time. A script to start the program several times with different random
seed values is given below. If run on different
machines, the different programs must not operate in the same directory
because of the name of the output file name. Also each machine should be
assigned a different range of random seed values in this case.

Example Script:
.EX
#!/bin/sh
i=0
while [ $i -lt 100 ]
do
    i=`expr $i + 1`
    (/bin/time syssched $i ws94.dat 2>&1) > 94sc.$i
    mv studliste studl.$i
done
.EE

The example script also records timing information of the scheduler run.
For a perl script to produce a summary with maximum, minimum, and average
scores as well as number of students given one of their wish groups and
the execution time information see 
.I sysreport(1). Data of former semesters for a test run can be found in
/quasi/local/src/syssched/examples. The
.I ws94.dat
file was produced with 
.I anm2sched.


.SH BUGS
A good solution is not found on every invocation with every random seed.
Sometimes even groups with one, two, or more than 31 students are
produced. This is not a problem of the heuristics but a problem of the
heuristic search algorith used.
The program should be run several times with different random
seeds and the best solution found should be used.

The student list may not be directly imported into
.I spor2,
it must be sorted first. This is considered a bug of
.I spor2.

The default output file name for the list of students is
.I studliste
and cannot be changed.

.SH SEE ALSO
.BR sysreport(1),
.BR anm2sched(1),
Gunter Dueck, Tobias Scheuer and Hans-Martin Wallmeier,
"Toleranzschwelle und Sintflut: neue Ideen zur Optimierung",
Spektrum der Wissenschaft 3/1993 pp. 42-51.

.SH AUTHOR
Peter Holzer (prototype version),
Ralf Schlatterbeck

